- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# Ipopt::SymLinearSolver Class Reference

Base class for all derived symmetric linear solvers. More...

`#include <IpSymLinearSolver.hpp>`

Inheritance diagram for Ipopt::SymLinearSolver:

[legend]
Collaboration diagram for Ipopt::SymLinearSolver:

[legend]
List of all members.

## Public Member Functions
virtual bool | InitializeImpl (const OptionsList &options, const std::string &prefix)=0
| overloaded from AlgorithmStrategyObject
Constructor/Destructor
| SymLinearSolver ()
virtual | ~SymLinearSolver ()
Methods for requesting solution of the linear system.
virtual ESymSolverStatus | MultiSolve (const SymMatrix &A, std::vector< SmartPtr< const Vector > > &rhsV, std::vector< SmartPtr< Vector > > &solV, bool check_NegEVals, Index numberOfNegEVals)=0
| Solve operation for multiple right hand sides.
ESymSolverStatus | Solve (const SymMatrix &A, const Vector &rhs, Vector &sol, bool check_NegEVals, Index numberOfNegEVals)
| Solve operation for a single right hand side.
virtual Index | NumberOfNegEVals () const =0
| Number of negative eigenvalues detected during last factorization.
virtual bool | IncreaseQuality ()=0
| Request to increase quality of solution for next solve.
virtual bool | ProvidesInertia () const =0
| Query whether inertia is computed by linear solver.

## Detailed Description

Base class for all derived symmetric linear solvers.

In the full space version of Ipopt a large linear system has to be solved for the augmented system. This case is meant to be the base class for all derived linear solvers for symmetric matrices (of type SymMatrix).

A linear solver can be used repeatedly for matrices with identical structure of nonzero elements. The nonzero structure of those matrices must not be changed between calls.

The called might ask the solver to only solve the linear system if the system is nonsingular, and if the number of negative eigenvalues matches a given number.

Definition at line 50 of file IpSymLinearSolver.hpp.

## Constructor & Destructor Documentation

Ipopt::SymLinearSolver::SymLinearSolver | ( |  | ) | `[inline]`

Definition at line 55 of file IpSymLinearSolver.hpp.

virtual Ipopt::SymLinearSolver::~SymLinearSolver | ( |  | ) | `[inline, virtual]`

Definition at line 58 of file IpSymLinearSolver.hpp.

## Member Function Documentation

virtual bool Ipopt::SymLinearSolver::InitializeImpl | ( | const OptionsList & | options,
|  | const std::string & | prefix |
| ) |  |  | `[pure virtual]`

overloaded from AlgorithmStrategyObject

Implements Ipopt::AlgorithmStrategyObject.

Implemented in Ipopt::TSymLinearSolver.

virtual ESymSolverStatus Ipopt::SymLinearSolver::MultiSolve | ( | const SymMatrix & | A,
|  | std::vector< SmartPtr< const Vector > > & | rhsV,
|  | std::vector< SmartPtr< Vector > > & | solV,
|  | bool | check_NegEVals,
|  | Index | numberOfNegEVals |
| ) |  |  | `[pure virtual]`

Solve operation for multiple right hand sides.

Solves the linear system A * Sol = Rhs with multiple right hand sides. If necessary, A is factorized. Correct solutions are only guaranteed if the return values is SYMSOLVER_SUCCESS. The solver will return SYMSOLVER_SINGULAR if the linear system is singular, and it will return SYMSOLVER_WRONG_INERTIA if check_NegEVals is true and the number of negative eigenvalues in the matrix does not match numberOfNegEVals.

check_NegEVals cannot be chosen true, if ProvidesInertia() returns false.

Implemented in Ipopt::TSymLinearSolver.

Referenced by Solve().

ESymSolverStatus Ipopt::SymLinearSolver::Solve | ( | const SymMatrix & | A,
|  | const Vector & | rhs,
|  | Vector & | sol,
|  | bool | check_NegEVals,
|  | Index | numberOfNegEVals |
| ) |  |  | `[inline]`

Solve operation for a single right hand side.

Solves the linear system A * Sol = Rhs. See MultiSolve for more details.

Definition at line 89 of file IpSymLinearSolver.hpp.

References MultiSolve().

virtual Index Ipopt::SymLinearSolver::NumberOfNegEVals | ( |  | ) | const`[pure virtual]`

Number of negative eigenvalues detected during last factorization.

Returns the number of negative eigenvalues of the most recent factorized matrix. This must not be called if the linear solver does not compute this quantities (see ProvidesInertia).

Implemented in Ipopt::TSymLinearSolver.

virtual bool Ipopt::SymLinearSolver::IncreaseQuality | ( |  | ) | `[pure virtual]`

Request to increase quality of solution for next solve.

Ask linear solver to increase quality of solution for the next solve (e.g. increase pivot tolerance). Returns false, if this is not possible (e.g. maximal pivot tolerance already used.)

Implemented in Ipopt::TSymLinearSolver.

virtual bool Ipopt::SymLinearSolver::ProvidesInertia | ( |  | ) | const`[pure virtual]`

Query whether inertia is computed by linear solver.

Returns true, if linear solver provides inertia.

Implemented in Ipopt::TSymLinearSolver.

The documentation for this class was generated from the following file:

- /home/coin/SVN-release/Ipopt-3.2.1/Ipopt/src/Algorithm/LinearSolvers/IpSymLinearSolver.hpp